/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GOOGLE, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebCore {

enum EventInterface {
#if ENABLE(APPLE_PAY)
    ApplePayCancelEventInterfaceType = 1,
    ApplePayPaymentAuthorizedEventInterfaceType = 2,
    ApplePayPaymentMethodSelectedEventInterfaceType = 3,
    ApplePayShippingContactSelectedEventInterfaceType = 4,
    ApplePayShippingMethodSelectedEventInterfaceType = 5,
    ApplePayValidateMerchantEventInterfaceType = 6,
#endif
#if ENABLE(APPLE_PAY_COUPON_CODE)
    ApplePayCouponCodeChangedEventInterfaceType = 7,
#endif
#if ENABLE(DECLARATIVE_WEB_PUSH)
    PushNotificationEventInterfaceType = 8,
#endif
#if ENABLE(DEVICE_ORIENTATION)
    DeviceMotionEventInterfaceType = 9,
    DeviceOrientationEventInterfaceType = 10,
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    MediaEncryptedEventInterfaceType = 11,
    MediaKeyMessageEventInterfaceType = 12,
#endif
#if ENABLE(GAMEPAD)
    GamepadEventInterfaceType = 13,
#endif
#if ENABLE(IOS_GESTURE_EVENTS) || ENABLE(MAC_GESTURE_EVENTS)
    GestureEventInterfaceType = 14,
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    WebKitMediaKeyMessageEventInterfaceType = 15,
    WebKitMediaKeyNeededEventInterfaceType = 16,
#endif
#if ENABLE(MEDIA_RECORDER)
    BlobEventInterfaceType = 17,
    MediaRecorderErrorEventInterfaceType = 18,
#endif
#if ENABLE(MEDIA_SOURCE)
    BufferedChangeEventInterfaceType = 19,
#endif
#if ENABLE(MEDIA_STREAM)
    MediaStreamTrackEventInterfaceType = 20,
    OverconstrainedErrorEventInterfaceType = 21,
#endif
#if ENABLE(NOTIFICATION_EVENT)
    NotificationEventInterfaceType = 22,
#endif
#if ENABLE(ORIENTATION_EVENTS)
#endif
#if ENABLE(PAYMENT_REQUEST)
    MerchantValidationEventInterfaceType = 23,
    PaymentMethodChangeEventInterfaceType = 24,
    PaymentRequestUpdateEventInterfaceType = 25,
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    PictureInPictureEventInterfaceType = 26,
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    SpeechSynthesisErrorEventInterfaceType = 27,
    SpeechSynthesisEventInterfaceType = 28,
#endif
#if ENABLE(TOUCH_EVENTS)
    TouchEventInterfaceType = 29,
#endif
#if ENABLE(VIDEO)
    TrackEventInterfaceType = 30,
#endif
#if ENABLE(WEBGL)
    WebGLContextEventInterfaceType = 31,
#endif
#if ENABLE(WEBXR)
    XRInputSourceEventInterfaceType = 32,
    XRInputSourcesChangeEventInterfaceType = 33,
    XRReferenceSpaceEventInterfaceType = 34,
    XRSessionEventInterfaceType = 35,
#endif
#if ENABLE(WEB_AUDIO)
    AudioProcessingEventInterfaceType = 36,
    OfflineAudioCompletionEventInterfaceType = 37,
#endif
#if ENABLE(WEB_RTC)
    RTCDTMFToneChangeEventInterfaceType = 38,
    RTCDataChannelEventInterfaceType = 39,
    RTCErrorEventInterfaceType = 40,
    RTCPeerConnectionIceErrorEventInterfaceType = 41,
    RTCPeerConnectionIceEventInterfaceType = 42,
    RTCRtpSFrameTransformErrorEventInterfaceType = 43,
    RTCTrackEventInterfaceType = 44,
    RTCTransformEventInterfaceType = 45,
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET_AVAILABILITY_API)
    WebKitPlaybackTargetAvailabilityEventInterfaceType = 46,
#endif
    AnimationPlaybackEventInterfaceType = 47,
    BackgroundFetchEventInterfaceType = 48,
    BackgroundFetchUpdateUIEventInterfaceType = 49,
    BeforeUnloadEventInterfaceType = 50,
    CSSAnimationEventInterfaceType = 51,
    CSSTransitionEventInterfaceType = 52,
    ClipboardEventInterfaceType = 53,
    CloseEventInterfaceType = 54,
    CompositionEventInterfaceType = 55,
    ContentVisibilityAutoStateChangeEventInterfaceType = 56,
    CookieChangeEventInterfaceType = 57,
    CustomEventInterfaceType = 58,
    DragEventInterfaceType = 59,
    ErrorEventInterfaceType = 60,
    EventInterfaceType = 61,
    ExtendableCookieChangeEventInterfaceType = 62,
    ExtendableEventInterfaceType = 63,
    ExtendableMessageEventInterfaceType = 64,
    FetchEventInterfaceType = 65,
    FocusEventInterfaceType = 66,
    FormDataEventInterfaceType = 67,
    HashChangeEventInterfaceType = 68,
    IDBVersionChangeEventInterfaceType = 69,
    InputEventInterfaceType = 70,
    InvokeEventInterfaceType = 71,
    KeyboardEventInterfaceType = 72,
    MediaQueryListEventInterfaceType = 73,
    MessageEventInterfaceType = 74,
    MouseEventInterfaceType = 75,
    MutationEventInterfaceType = 76,
    NavigateEventInterfaceType = 77,
    NavigationCurrentEntryChangeEventInterfaceType = 78,
    OverflowEventInterfaceType = 79,
    PageTransitionEventInterfaceType = 80,
    PointerEventInterfaceType = 81,
    PopStateEventInterfaceType = 82,
    ProgressEventInterfaceType = 83,
    PromiseRejectionEventInterfaceType = 84,
    PushEventInterfaceType = 85,
    PushSubscriptionChangeEventInterfaceType = 86,
    SecurityPolicyViolationEventInterfaceType = 87,
    SpeechRecognitionErrorEventInterfaceType = 88,
    SpeechRecognitionEventInterfaceType = 89,
    StorageEventInterfaceType = 90,
    SubmitEventInterfaceType = 91,
    TextEventInterfaceType = 92,
    ToggleEventInterfaceType = 93,
    UIEventInterfaceType = 94,
    WheelEventInterfaceType = 95,
    XMLHttpRequestProgressEventInterfaceType = 96,
};

} // namespace WebCore
