/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GOOGLE, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebCore {

enum EventTargetInterface {
#if ENABLE(APPLE_PAY)
    ApplePaySessionEventTargetInterfaceType = 1,
#endif
#if ENABLE(DOM_AUDIO_SESSION)
    DOMAudioSessionEventTargetInterfaceType = 2,
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    MediaKeySessionEventTargetInterfaceType = 3,
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    WebKitMediaKeySessionEventTargetInterfaceType = 4,
#endif
#if ENABLE(MEDIA_RECORDER)
    MediaRecorderEventTargetInterfaceType = 5,
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR)
    MediaSessionCoordinatorEventTargetInterfaceType = 6,
#endif
#if ENABLE(MEDIA_SOURCE)
    ManagedMediaSourceEventTargetInterfaceType = 7,
    ManagedSourceBufferEventTargetInterfaceType = 8,
    MediaSourceEventTargetInterfaceType = 9,
    SourceBufferEventTargetInterfaceType = 10,
    SourceBufferListEventTargetInterfaceType = 11,
#endif
#if ENABLE(MEDIA_STREAM)
    MediaDevicesEventTargetInterfaceType = 12,
    MediaStreamEventTargetInterfaceType = 13,
    MediaStreamTrackEventTargetInterfaceType = 14,
#endif
#if ENABLE(NOTIFICATIONS)
    NotificationEventTargetInterfaceType = 15,
#endif
#if ENABLE(OFFSCREEN_CANVAS)
    OffscreenCanvasEventTargetInterfaceType = 16,
#endif
#if ENABLE(PAYMENT_REQUEST)
    PaymentRequestEventTargetInterfaceType = 17,
    PaymentResponseEventTargetInterfaceType = 18,
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    PictureInPictureWindowEventTargetInterfaceType = 19,
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    SpeechSynthesisEventTargetInterfaceType = 20,
    SpeechSynthesisUtteranceEventTargetInterfaceType = 21,
#endif
#if ENABLE(VIDEO)
    AudioTrackListEventTargetInterfaceType = 22,
    MediaControllerEventTargetInterfaceType = 23,
    TextTrackEventTargetInterfaceType = 24,
    TextTrackCueEventTargetInterfaceType = 25,
    TextTrackCueGenericEventTargetInterfaceType = 26,
    TextTrackListEventTargetInterfaceType = 27,
    VideoTrackListEventTargetInterfaceType = 28,
#endif
#if ENABLE(WEBXR)
    WebXRLayerEventTargetInterfaceType = 29,
    WebXRSessionEventTargetInterfaceType = 30,
    WebXRSpaceEventTargetInterfaceType = 31,
    WebXRSystemEventTargetInterfaceType = 32,
#endif
#if ENABLE(WEB_AUDIO)
    AudioNodeEventTargetInterfaceType = 33,
    BaseAudioContextEventTargetInterfaceType = 34,
#endif
#if ENABLE(WEB_CODECS)
    WebCodecsAudioDecoderEventTargetInterfaceType = 35,
    WebCodecsAudioEncoderEventTargetInterfaceType = 36,
    WebCodecsVideoDecoderEventTargetInterfaceType = 37,
    WebCodecsVideoEncoderEventTargetInterfaceType = 38,
#endif
#if ENABLE(WEB_RTC)
    RTCDTMFSenderEventTargetInterfaceType = 39,
    RTCDataChannelEventTargetInterfaceType = 40,
    RTCDtlsTransportEventTargetInterfaceType = 41,
    RTCIceTransportEventTargetInterfaceType = 42,
    RTCPeerConnectionEventTargetInterfaceType = 43,
    RTCRtpSFrameTransformEventTargetInterfaceType = 44,
    RTCSctpTransportEventTargetInterfaceType = 45,
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    RemotePlaybackEventTargetInterfaceType = 46,
#endif
    EventTargetInterfaceType = 47,
    AbortSignalEventTargetInterfaceType = 48,
    BackgroundFetchRegistrationEventTargetInterfaceType = 49,
    BroadcastChannelEventTargetInterfaceType = 50,
    ClipboardEventTargetInterfaceType = 51,
    CookieStoreEventTargetInterfaceType = 52,
    DOMApplicationCacheEventTargetInterfaceType = 53,
    DedicatedWorkerGlobalScopeEventTargetInterfaceType = 54,
    EventSourceEventTargetInterfaceType = 55,
    FileReaderEventTargetInterfaceType = 56,
    FontFaceSetEventTargetInterfaceType = 57,
    GPUDeviceEventTargetInterfaceType = 58,
    IDBDatabaseEventTargetInterfaceType = 59,
    IDBOpenDBRequestEventTargetInterfaceType = 60,
    IDBRequestEventTargetInterfaceType = 61,
    IDBTransactionEventTargetInterfaceType = 62,
    LocalDOMWindowEventTargetInterfaceType = 63,
    MediaQueryListEventTargetInterfaceType = 64,
    MessagePortEventTargetInterfaceType = 65,
    NavigationEventTargetInterfaceType = 66,
    NavigationHistoryEntryEventTargetInterfaceType = 67,
    NodeEventTargetInterfaceType = 68,
    PerformanceEventTargetInterfaceType = 69,
    PermissionStatusEventTargetInterfaceType = 70,
    ScreenOrientationEventTargetInterfaceType = 71,
    ServiceWorkerEventTargetInterfaceType = 72,
    ServiceWorkerContainerEventTargetInterfaceType = 73,
    ServiceWorkerGlobalScopeEventTargetInterfaceType = 74,
    ServiceWorkerRegistrationEventTargetInterfaceType = 75,
    SharedWorkerEventTargetInterfaceType = 76,
    SharedWorkerGlobalScopeEventTargetInterfaceType = 77,
    SpeechRecognitionEventTargetInterfaceType = 78,
    VisualViewportEventTargetInterfaceType = 79,
    WakeLockSentinelEventTargetInterfaceType = 80,
    WebAnimationEventTargetInterfaceType = 81,
    WebSocketEventTargetInterfaceType = 82,
    WorkerEventTargetInterfaceType = 83,
    WorkletGlobalScopeEventTargetInterfaceType = 84,
    XMLHttpRequestEventTargetInterfaceType = 85,
    XMLHttpRequestUploadEventTargetInterfaceType = 86,
};

} // namespace WebCore
