/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDetectedFace.h"

#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMRectReadOnly.h"
#include "JSLandmark.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> DetectedFace convertDictionary<DetectedFace>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    DetectedFace result;
    JSValue boundingBoxValue;
    if (isNullOrUndefined)
        boundingBoxValue = jsUndefined();
    else {
        boundingBoxValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "boundingBox"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!boundingBoxValue.isUndefined()) {
        result.boundingBox = convert<IDLInterface<DOMRectReadOnly>>(lexicalGlobalObject, boundingBoxValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "boundingBox", "DetectedFace", "DOMRectReadOnly");
        return { };
    }
    JSValue landmarksValue;
    if (isNullOrUndefined)
        landmarksValue = jsUndefined();
    else {
        landmarksValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "landmarks"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!landmarksValue.isUndefined()) {
        result.landmarks = convert<IDLNullable<IDLFrozenArray<IDLDictionary<Landmark>>>>(lexicalGlobalObject, landmarksValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "landmarks", "DetectedFace", "FrozenArray");
        return { };
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const DetectedFace& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto boundingBoxValue = toJS<IDLInterface<DOMRectReadOnly>>(lexicalGlobalObject, globalObject, throwScope, dictionary.boundingBox);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "boundingBox"_s), boundingBoxValue);
    auto landmarksValue = toJS<IDLNullable<IDLFrozenArray<IDLDictionary<Landmark>>>>(lexicalGlobalObject, globalObject, throwScope, dictionary.landmarks);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "landmarks"_s), landmarksValue);
    return result;
}

} // namespace WebCore
