/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSEXTsRGB.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMBinding.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include "WebCoreOpaqueRootInlines.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

class JSEXTsRGBPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSEXTsRGBPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSEXTsRGBPrototype* ptr = new (NotNull, JSC::allocateCell<JSEXTsRGBPrototype>(vm)) JSEXTsRGBPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSEXTsRGBPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSEXTsRGBPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSEXTsRGBPrototype, JSEXTsRGBPrototype::Base);

/* Hash table for prototype */

static const HashTableValue JSEXTsRGBPrototypeTableValues[] =
{
    { "SRGB_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8C40 } },
    { "SRGB_ALPHA_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8C42 } },
    { "SRGB8_ALPHA8_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8C43 } },
    { "FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8210 } },
};

const ClassInfo JSEXTsRGBPrototype::s_info = { "EXTsRGB"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSEXTsRGBPrototype) };

void JSEXTsRGBPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSEXTsRGB::info(), JSEXTsRGBPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSEXTsRGB::s_info = { "EXTsRGB"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSEXTsRGB) };

JSEXTsRGB::JSEXTsRGB(Structure* structure, JSDOMGlobalObject& globalObject, Ref<EXTsRGB>&& impl)
    : JSDOMWrapper<EXTsRGB>(structure, globalObject, WTFMove(impl))
{
}

static_assert(!std::is_base_of<ActiveDOMObject, EXTsRGB>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSEXTsRGB::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSEXTsRGBPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype());
    structure->setMayBePrototype(true);
    return JSEXTsRGBPrototype::create(vm, &globalObject, structure);
}

JSObject* JSEXTsRGB::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSEXTsRGB>(vm, globalObject);
}

void JSEXTsRGB::destroy(JSC::JSCell* cell)
{
    JSEXTsRGB* thisObject = static_cast<JSEXTsRGB*>(cell);
    thisObject->JSEXTsRGB::~JSEXTsRGB();
}

JSC::GCClient::IsoSubspace* JSEXTsRGB::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSEXTsRGB, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForEXTsRGB.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForEXTsRGB = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForEXTsRGB.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForEXTsRGB = std::forward<decltype(space)>(space); }
    );
}

void JSEXTsRGB::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSEXTsRGB*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url "_s + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSEXTsRGBOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsEXTsRGB = jsCast<JSEXTsRGB*>(handle.slot()->asCell());
    auto& owner = jsEXTsRGB->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from jsEXTsRGB";
    return containsWebCoreOpaqueRoot(visitor, owner);
}

void JSEXTsRGBOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsEXTsRGB = static_cast<JSEXTsRGB*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsEXTsRGB->wrapped(), jsEXTsRGB);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7EXTsRGB@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore7EXTsRGBE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<EXTsRGB>&& impl)
{

    if constexpr (std::is_polymorphic_v<EXTsRGB>) {
#if ENABLE(BINDING_INTEGRITY)
        const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7EXTsRGB@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore7EXTsRGBE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // EXTsRGB has subclasses. If EXTsRGB has subclasses that get passed
        // to toJS() we currently require EXTsRGB you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    }
    return createWrapper<EXTsRGB>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, EXTsRGB& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

EXTsRGB* JSEXTsRGB::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSEXTsRGB*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBGL)
