/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSPerformanceResourceTiming.h"
#include "PerformanceNavigationTiming.h"

namespace WebCore {

class JSPerformanceNavigationTiming : public JSPerformanceResourceTiming {
public:
    using Base = JSPerformanceResourceTiming;
    using DOMWrapped = PerformanceNavigationTiming;
    static JSPerformanceNavigationTiming* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<PerformanceNavigationTiming>&& impl)
    {
        JSPerformanceNavigationTiming* ptr = new (NotNull, JSC::allocateCell<JSPerformanceNavigationTiming>(globalObject->vm())) JSPerformanceNavigationTiming(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    PerformanceNavigationTiming& wrapped() const
    {
        return static_cast<PerformanceNavigationTiming&>(Base::wrapped());
    }

    Ref<PerformanceNavigationTiming> protectedWrapped() const;

protected:
    JSPerformanceNavigationTiming(JSC::Structure*, JSDOMGlobalObject&, Ref<PerformanceNavigationTiming>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};


template<> struct JSDOMWrapperConverterTraits<PerformanceNavigationTiming> {
    using WrapperClass = JSPerformanceNavigationTiming;
    using ToWrappedReturnType = PerformanceNavigationTiming*;
};
String convertEnumerationToString(PerformanceNavigationTiming::NavigationType);
template<> JSC::JSString* convertEnumerationToJS(JSC::VM&, PerformanceNavigationTiming::NavigationType);

template<> std::optional<PerformanceNavigationTiming::NavigationType> parseEnumerationFromString<PerformanceNavigationTiming::NavigationType>(const String&);
template<> std::optional<PerformanceNavigationTiming::NavigationType> parseEnumeration<PerformanceNavigationTiming::NavigationType>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<PerformanceNavigationTiming::NavigationType>();


} // namespace WebCore
