/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSRTCIceTcpCandidateType.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(RTCIceTcpCandidateType enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("active"),
        MAKE_STATIC_STRING_IMPL("passive"),
        MAKE_STATIC_STRING_IMPL("so"),
    };
    static_assert(static_cast<size_t>(RTCIceTcpCandidateType::Active) == 0, "RTCIceTcpCandidateType::Active is not 0 as expected");
    static_assert(static_cast<size_t>(RTCIceTcpCandidateType::Passive) == 1, "RTCIceTcpCandidateType::Passive is not 1 as expected");
    static_assert(static_cast<size_t>(RTCIceTcpCandidateType::So) == 2, "RTCIceTcpCandidateType::So is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, RTCIceTcpCandidateType enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<RTCIceTcpCandidateType> parseEnumerationFromString<RTCIceTcpCandidateType>(const String& stringValue)
{
    static constexpr std::pair<ComparableASCIILiteral, RTCIceTcpCandidateType> mappings[] = {
        { "active", RTCIceTcpCandidateType::Active },
        { "passive", RTCIceTcpCandidateType::Passive },
        { "so", RTCIceTcpCandidateType::So },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<RTCIceTcpCandidateType> parseEnumeration<RTCIceTcpCandidateType>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<RTCIceTcpCandidateType>(value.toWTFString(&lexicalGlobalObject));
}

template<> const char* expectedEnumerationValues<RTCIceTcpCandidateType>()
{
    return "\"active\", \"passive\", \"so\"";
}

} // namespace WebCore
