/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebTransportSendStreamStats.h"

#include "JSDOMConvertNumbers.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> WebTransportSendStreamStats convertDictionary<WebTransportSendStreamStats>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    WebTransportSendStreamStats result;
    JSValue bytesAcknowledgedValue;
    if (isNullOrUndefined)
        bytesAcknowledgedValue = jsUndefined();
    else {
        bytesAcknowledgedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesAcknowledged"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesAcknowledgedValue.isUndefined()) {
        result.bytesAcknowledged = convert<IDLUnsignedLongLong>(lexicalGlobalObject, bytesAcknowledgedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue bytesSentValue;
    if (isNullOrUndefined)
        bytesSentValue = jsUndefined();
    else {
        bytesSentValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesSent"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesSentValue.isUndefined()) {
        result.bytesSent = convert<IDLUnsignedLongLong>(lexicalGlobalObject, bytesSentValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue bytesWrittenValue;
    if (isNullOrUndefined)
        bytesWrittenValue = jsUndefined();
    else {
        bytesWrittenValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesWritten"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesWrittenValue.isUndefined()) {
        result.bytesWritten = convert<IDLUnsignedLongLong>(lexicalGlobalObject, bytesWrittenValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue timestampValue;
    if (isNullOrUndefined)
        timestampValue = jsUndefined();
    else {
        timestampValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "timestamp"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!timestampValue.isUndefined()) {
        result.timestamp = convert<IDLDouble>(lexicalGlobalObject, timestampValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
