/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebTransportStats.h"

#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSWebTransportDatagramStats.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> WebTransportStats convertDictionary<WebTransportStats>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    WebTransportStats result;
    JSValue bytesReceivedValue;
    if (isNullOrUndefined)
        bytesReceivedValue = jsUndefined();
    else {
        bytesReceivedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesReceived"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesReceivedValue.isUndefined()) {
        result.bytesReceived = convert<IDLUnsignedLongLong>(lexicalGlobalObject, bytesReceivedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue bytesSentValue;
    if (isNullOrUndefined)
        bytesSentValue = jsUndefined();
    else {
        bytesSentValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesSent"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesSentValue.isUndefined()) {
        result.bytesSent = convert<IDLUnsignedLongLong>(lexicalGlobalObject, bytesSentValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue datagramsValue;
    if (isNullOrUndefined)
        datagramsValue = jsUndefined();
    else {
        datagramsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "datagrams"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!datagramsValue.isUndefined()) {
        result.datagrams = convert<IDLDictionary<WebTransportDatagramStats>>(lexicalGlobalObject, datagramsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue estimatedSendRateValue;
    if (isNullOrUndefined)
        estimatedSendRateValue = jsUndefined();
    else {
        estimatedSendRateValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "estimatedSendRate"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!estimatedSendRateValue.isUndefined()) {
        result.estimatedSendRate = convert<IDLNullable<IDLUnsignedLongLong>>(lexicalGlobalObject, estimatedSendRateValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue minRttValue;
    if (isNullOrUndefined)
        minRttValue = jsUndefined();
    else {
        minRttValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "minRtt"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!minRttValue.isUndefined()) {
        result.minRtt = convert<IDLDouble>(lexicalGlobalObject, minRttValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue numIncomingStreamsCreatedValue;
    if (isNullOrUndefined)
        numIncomingStreamsCreatedValue = jsUndefined();
    else {
        numIncomingStreamsCreatedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "numIncomingStreamsCreated"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!numIncomingStreamsCreatedValue.isUndefined()) {
        result.numIncomingStreamsCreated = convert<IDLUnsignedLong>(lexicalGlobalObject, numIncomingStreamsCreatedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue numOutgoingStreamsCreatedValue;
    if (isNullOrUndefined)
        numOutgoingStreamsCreatedValue = jsUndefined();
    else {
        numOutgoingStreamsCreatedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "numOutgoingStreamsCreated"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!numOutgoingStreamsCreatedValue.isUndefined()) {
        result.numOutgoingStreamsCreated = convert<IDLUnsignedLong>(lexicalGlobalObject, numOutgoingStreamsCreatedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue packetsLostValue;
    if (isNullOrUndefined)
        packetsLostValue = jsUndefined();
    else {
        packetsLostValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "packetsLost"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!packetsLostValue.isUndefined()) {
        result.packetsLost = convert<IDLUnsignedLongLong>(lexicalGlobalObject, packetsLostValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue packetsReceivedValue;
    if (isNullOrUndefined)
        packetsReceivedValue = jsUndefined();
    else {
        packetsReceivedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "packetsReceived"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!packetsReceivedValue.isUndefined()) {
        result.packetsReceived = convert<IDLUnsignedLongLong>(lexicalGlobalObject, packetsReceivedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue packetsSentValue;
    if (isNullOrUndefined)
        packetsSentValue = jsUndefined();
    else {
        packetsSentValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "packetsSent"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!packetsSentValue.isUndefined()) {
        result.packetsSent = convert<IDLUnsignedLongLong>(lexicalGlobalObject, packetsSentValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue rttVariationValue;
    if (isNullOrUndefined)
        rttVariationValue = jsUndefined();
    else {
        rttVariationValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "rttVariation"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!rttVariationValue.isUndefined()) {
        result.rttVariation = convert<IDLDouble>(lexicalGlobalObject, rttVariationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue smoothedRttValue;
    if (isNullOrUndefined)
        smoothedRttValue = jsUndefined();
    else {
        smoothedRttValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "smoothedRtt"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!smoothedRttValue.isUndefined()) {
        result.smoothedRtt = convert<IDLDouble>(lexicalGlobalObject, smoothedRttValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue timestampValue;
    if (isNullOrUndefined)
        timestampValue = jsUndefined();
    else {
        timestampValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "timestamp"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!timestampValue.isUndefined()) {
        result.timestamp = convert<IDLDouble>(lexicalGlobalObject, timestampValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
