/*
 * Copyright (C) 2014-2024 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

// This file is automatically generated from CSSPseudoSelectors.json by the process-css-pseudo-selectors.py script, do not edit by hand.

#pragma once

#include <wtf/Forward.h>

namespace WebCore::UserAgentParts {

#if ENABLE(SERVICE_CONTROLS)
const AtomString& appleAttachmentControlsContainer();
#endif
const AtomString& internalLoadingAutoFillButton();
const AtomString& webkitCapsLockIndicator();
const AtomString& webkitColorSwatch();
const AtomString& webkitColorSwatchWrapper();
const AtomString& webkitContactsAutoFillButton();
const AtomString& webkitCredentialsAutoFillButton();
const AtomString& webkitCreditCardAutoFillButton();
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDateAndTimeValue();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEdit();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditDayField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditFieldsWrapper();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditHourField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditMeridiemField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditMillisecondField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditMinuteField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditMonthField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditSecondField();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditText();
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
const AtomString& webkitDatetimeEditYearField();
#endif
const AtomString& webkitDetailsMarker();
const AtomString& webkitGenericCueRoot();
const AtomString& webkitInnerSpinButton();
const AtomString& webkitListButton();
const AtomString& webkitMediaTextTrackContainer();
const AtomString& webkitMediaTextTrackDisplay();
const AtomString& webkitMediaTextTrackDisplayBackdrop();
const AtomString& webkitMediaTextTrackRegion();
const AtomString& webkitMediaTextTrackRegionContainer();
const AtomString& webkitMeterBar();
const AtomString& webkitMeterEvenLessGoodValue();
const AtomString& webkitMeterInnerElement();
const AtomString& webkitMeterOptimumValue();
const AtomString& webkitMeterSuboptimumValue();
const AtomString& webkitProgressBar();
const AtomString& webkitProgressInnerElement();
const AtomString& webkitProgressValue();
const AtomString& webkitSearchCancelButton();
const AtomString& webkitSearchDecoration();
const AtomString& webkitSearchResultsButton();
const AtomString& webkitSearchResultsDecoration();
const AtomString& webkitSliderContainer();
const AtomString& webkitSliderRunnableTrack();
const AtomString& webkitSliderThumb();
const AtomString& webkitStrongPasswordAutoFillButton();
const AtomString& webkitTextfieldDecorationContainer();
const AtomString& webkitValidationBubble();
const AtomString& webkitValidationBubbleArrow();
const AtomString& webkitValidationBubbleArrowClipper();
const AtomString& webkitValidationBubbleBody();
const AtomString& webkitValidationBubbleHeading();
const AtomString& webkitValidationBubbleIcon();
const AtomString& webkitValidationBubbleMessage();
const AtomString& webkitValidationBubbleTextBlock();
#if ENABLE(VIDEO)
const AtomString& cue();
#endif
const AtomString& fileSelectorButton();
const AtomString& placeholder();
const AtomString& thumb();
const AtomString& track();

} // WebCore::UserAgentParts
